#!/usr/bin/env python3

import time, subprocess
import RPi.GPIO as GPIO

from SCP import scp

IR_PIN = 3

GPIO.setmode(GPIO.BOARD)
GPIO.setup(IR_PIN, GPIO.OUT)
# set cameramode to normal; GPIO.LOW would enable infrared mode
GPIO.output(IR_PIN, GPIO.HIGH)

def person_detect():
    # initialize the HOG descriptor/person detector
    hog = cv2.HOGDescriptor()
    hog.setSVMDetector(cv2.HOGDescriptor_getDefaultPeopleDetector())

    # loop over the image paths
    for imagePath in paths.list_images(args["images"]):
        # load the image and resize it to (1) reduce detection time
        # and (2) improve detection accuracy
        image = cv2.imread(imagePath)
        image = imutils.resize(image, width=min(400, image.shape[1]))
        orig = image.copy()

        # detect people in the image
        (rects, weights) = hog.detectMultiScale(image, winStride=(4, 4),
        padding=(8, 8), scale=1.05)

        # draw the original bounding boxes
        for (x, y, w, h) in rects:
            cv2.rectangle(orig, (x, y), (x + w, y + h), (0, 0, 255), 2)

        # apply non-maxima suppression to the bounding boxes using a
        # fairly large overlap threshold to try to maintain overlapping
        # boxes that are still people
        rects = np.array([[x, y, x + w, y + h] for (x, y, w, h) in rects])
        pick = non_max_suppression(rects, probs=None, overlapThresh=0.65)

        # draw the final bounding boxes
        for (xA, yA, xB, yB) in pick:
            cv2.rectangle(image, (xA, yA), (xB, yB), (0, 255, 0), 2)

        # show some information on the number of bounding boxes
        filename = imagePath[imagePath.rfind("/") + 1:]
        print("[INFO] {}: {} original boxes, {} after suppression".format(filename, len(rects), len(pick)))


def main():
    i = 0

    try:
        while True:
            print("Gpio Low")
            time.sleep(2)

            # take image and scp it to the other pi
            print("take image...")
            subprocess.run(['raspistill', '-o', 'images/image' + str(i) + '.jpg'])
        

            #print("transfer image")
            #scp('images/image' + str(i) + '.jpg', '~/image' + str(i) + '.jpg', '192.168.252.1', 'pi', 'smarthome')

            i+=1

            if i>10:
                break
            #print("Gpio High")
            #GPIO.output(IR_PIN, GPIO.HIGH)
            #time.sleep(2)

            # take image and scp it to the other pi
            #print("take image...")
            #subprocess.run(['raspistill', '-o', 'image2.jpg'])
            
            #print("transfer image")
            #scp('image2.jpg', '~/image2.jpg', '192.168.252.1', 'pi', 'smarthome')

            #break

    except Exception as e:
        print(e)
    finally:
        GPIO.cleanup()

    #person_detect()

if __name__ == '__main__':
    main()
